#!/usr/bin/perl
#
# ワンセグ野郎字幕対応 2009/10/02
#
#use AT_YOUR_OWN_RISK;
use Time::Local;
use Encode;
#
# .SUB ファイルの置き場所
#my $TSFOLDER='c:\TS';
my $TSFOLDER='/media/disk/one24';
# 時間調整(秒)
my $Tadj = 1;
#
# UNK特殊文字辞書ファイル
my $UNKDIC="unk.txt";
#
$ENV{'QUERY_STRING'} =~/file=(.*xml)/;
my $file = $1;
#
my %unk=();
if(-f $UNKDIC){
    open(UNK,$UNKDIC);
    while(<UNK>){
	chop;
	my @tmp=split(/,/);
	$unk{$tmp[0]}=$tmp[1];
    }
    close(UNK);
}
#
print <<"_EOD_"
Content-Type: text/xml; charset=utf-8
Content-Disposition: attachment; filename="$file" 

<tt xmlns="http://www.w3.org/2006/10/ttaf1">
  <body>
    <div xml:id="captions">
_EOD_
;#
$file =~ /(\d{2})(\d{2})(\d{2})-(\d{2})(\d{2})(\d{2})-(\d{2})(\d{2})(\d{2})-(\d{2})/;
my $year = $1; my $mon  = $2; my $day  = $3;
my $shour= $4; my $smin = $5; my $ssec = $6;
my $ehour= $7; my $emin = $8; my $esec = $9; 
my $ch   =$10;

my $duration= ((($ehour >= $shour ? $ehour: $ehour+24) - $shour)*60+$emin-$smin)*60+$esec-$ssec;

my $stim = timelocal($ssec,$smin,$shour,$day,$mon-1,$year+100);
my $etim = $stim+$duration;

for(my $tim=timelocal(0,0,$shour,$day,$mon-1,$year+100);$tim<$etim;$tim+=3600){
    my($sec,$min,$hour,$day,$mon,$year,my $wday,my $yday,my$isdst) = localtime($tim);
    $year-=100; $mon+=1;
#    my $subfile = sprintf("%s\\%02d%02d%02d\\%02d%02d%02d%02d_Ch%02d.sub",
    my $subfile = sprintf("%s/%02d%02d%02d/%02d%02d%02d%02d_Ch%02d.sub",
			$TSFOLDER,$year,$mon,$day,$year,$mon,$day,$hour,$ch);
    if(-f $subfile){
	open(SUB,$subfile);
	my $capstr="";
	my $subtime=$psubtime=-1;
	while(<SUB>){
	    chop;
	    $_=~s/^(\d{2}):(\d{2}):(\d{2})//;
	    $subtime = timelocal($3,$2,$1,$day,$mon-1,$year+100) - $stim+ $Tadj;
	    if($subtime > $duration){last;}
	    if($subtime < 0        ){next;} 
	    $_=~s/^ *//;
	    if($_ ne ""){
		Encode::from_to($_,'euc-jp','utf-8');
		$_=~s/\[UNK(\w{4})\]/$unk{$1}/g;
		if($capstr eq ""){
		    $capstr = $_;
		    $psubtime=$subtime;
		}elsif($psubtime == $subtime){
		    $capstr.="<br/>";
		    $capstr.=$_;
		}else{
		    &print_caption($psubtime,$capstr);
		    $capstr=$_;
		    $psubtime=$subtime;
		}
	    }
	}
	close(SUB);
	if($capstr ne ""){
	    &print_caption($psubtime,$capstr);
	    $capstr="";
	}
    }
}
print <<"_EOD_";
    </div>
  </body>
</tt>
_EOD_
;#
#
sub print_caption{
    my($epoch,$str)=@_;
    printf("      <p begin=\"%02d:%02d:%02d\" end=\"%02d:%02d:%02d\">%s</p>\n",
	   int($epoch/3600),int(($epoch%3600)/60),$epoch%60,
	   int(($epoch+5)/3600),int((($epoch+5)%3600)/60),($epoch+5)%60,$str);
}	
;#
1;
